Merge branch 'rc/maint-http-fix'
[git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
12
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
19
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
22
23 Example:       git-rebase master~1 topic
24
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
29
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
36
37 OK_TO_SKIP_PRE_REBASE=
38 RESOLVEMSG="
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
42 "
43 unset newbase
44 strategy=recursive
45 do_merge=
46 dotest="$GIT_DIR"/rebase-merge
47 prec=4
48 verbose=
49 diffstat=$(git config --bool rebase.stat)
50 git_am_opt=
51 rebase_root=
52 force_rebase=
53
54 continue_merge () {
55         test -n "$prev_head" || die "prev_head must be defined"
56         test -d "$dotest" || die "$dotest directory does not exist"
57
58         unmerged=$(git ls-files -u)
59         if test -n "$unmerged"
60         then
61                 echo "You still have unmerged paths in your index"
62                 echo "did you forget to use git add?"
63                 die "$RESOLVEMSG"
64         fi
65
66         cmt=`cat "$dotest/current"`
67         if ! git diff-index --quiet --ignore-submodules HEAD --
68         then
69                 if ! git commit --no-verify -C "$cmt"
70                 then
71                         echo "Commit failed, please do not call \"git commit\""
72                         echo "directly, but instead do one of the following: "
73                         die "$RESOLVEMSG"
74                 fi
75                 if test -z "$GIT_QUIET"
76                 then
77                         printf "Committed: %0${prec}d " $msgnum
78                 fi
79         else
80                 if test -z "$GIT_QUIET"
81                 then
82                         printf "Already applied: %0${prec}d " $msgnum
83                 fi
84         fi
85         if test -z "$GIT_QUIET"
86         then
87                 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
88         fi
89
90         prev_head=`git rev-parse HEAD^0`
91         # save the resulting commit so we can read-tree on it later
92         echo "$prev_head" > "$dotest/prev_head"
93
94         # onto the next patch:
95         msgnum=$(($msgnum + 1))
96         echo "$msgnum" >"$dotest/msgnum"
97 }
98
99 call_merge () {
100         cmt="$(cat "$dotest/cmt.$1")"
101         echo "$cmt" > "$dotest/current"
102         hd=$(git rev-parse --verify HEAD)
103         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
104         msgnum=$(cat "$dotest/msgnum")
105         end=$(cat "$dotest/end")
106         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
107         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
108         export GITHEAD_$cmt GITHEAD_$hd
109         if test -n "$GIT_QUIET"
110         then
111                 export GIT_MERGE_VERBOSITY=1
112         fi
113         git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
114         rv=$?
115         case "$rv" in
116         0)
117                 unset GITHEAD_$cmt GITHEAD_$hd
118                 return
119                 ;;
120         1)
121                 git rerere
122                 die "$RESOLVEMSG"
123                 ;;
124         2)
125                 echo "Strategy: $rv $strategy failed, try another" 1>&2
126                 die "$RESOLVEMSG"
127                 ;;
128         *)
129                 die "Unknown exit code ($rv) from command:" \
130                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
131                 ;;
132         esac
133 }
134
135 move_to_original_branch () {
136         test -z "$head_name" &&
137                 head_name="$(cat "$dotest"/head-name)" &&
138                 onto="$(cat "$dotest"/onto)" &&
139                 orig_head="$(cat "$dotest"/orig-head)"
140         case "$head_name" in
141         refs/*)
142                 message="rebase finished: $head_name onto $onto"
143                 git update-ref -m "$message" \
144                         $head_name $(git rev-parse HEAD) $orig_head &&
145                 git symbolic-ref HEAD $head_name ||
146                 die "Could not move back to $head_name"
147                 ;;
148         esac
149 }
150
151 finish_rb_merge () {
152         move_to_original_branch
153         rm -r "$dotest"
154         say All done.
155 }
156
157 is_interactive () {
158         while test $# != 0
159         do
160                 case "$1" in
161                         -i|--interactive)
162                                 interactive_rebase=explicit
163                                 break
164                         ;;
165                         -p|--preserve-merges)
166                                 interactive_rebase=implied
167                         ;;
168                 esac
169                 shift
170         done
171
172         if [ "$interactive_rebase" = implied ]; then
173                 GIT_EDITOR=:
174                 export GIT_EDITOR
175         fi
176
177         test -n "$interactive_rebase" || test -f "$dotest"/interactive
178 }
179
180 run_pre_rebase_hook () {
181         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
182            test -x "$GIT_DIR/hooks/pre-rebase"
183         then
184                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
185                 die "The pre-rebase hook refused to rebase."
186         fi
187 }
188
189 test -f "$GIT_DIR"/rebase-apply/applying &&
190         die 'It looks like git-am is in progress. Cannot rebase.'
191
192 is_interactive "$@" && exec git-rebase--interactive "$@"
193
194 if test $# -eq 0
195 then
196         test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
197         test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
198                 die 'A rebase is in progress, try --continue, --skip or --abort.'
199         die "No arguments given and $GIT_DIR/rebase-apply already exists."
200 fi
201
202 while test $# != 0
203 do
204         case "$1" in
205         --no-verify)
206                 OK_TO_SKIP_PRE_REBASE=yes
207                 ;;
208         --continue)
209                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
210                         die "No rebase in progress?"
211
212                 git diff-files --quiet --ignore-submodules || {
213                         echo "You must edit all merge conflicts and then"
214                         echo "mark them as resolved using git add"
215                         exit 1
216                 }
217                 if test -d "$dotest"
218                 then
219                         prev_head=$(cat "$dotest/prev_head")
220                         end=$(cat "$dotest/end")
221                         msgnum=$(cat "$dotest/msgnum")
222                         onto=$(cat "$dotest/onto")
223                         GIT_QUIET=$(cat "$dotest/quiet")
224                         continue_merge
225                         while test "$msgnum" -le "$end"
226                         do
227                                 call_merge "$msgnum"
228                                 continue_merge
229                         done
230                         finish_rb_merge
231                         exit
232                 fi
233                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
234                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
235                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
236                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
237                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
238                 move_to_original_branch
239                 exit
240                 ;;
241         --skip)
242                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
243                         die "No rebase in progress?"
244
245                 git reset --hard HEAD || exit $?
246                 if test -d "$dotest"
247                 then
248                         git rerere clear
249                         prev_head=$(cat "$dotest/prev_head")
250                         end=$(cat "$dotest/end")
251                         msgnum=$(cat "$dotest/msgnum")
252                         msgnum=$(($msgnum + 1))
253                         onto=$(cat "$dotest/onto")
254                         GIT_QUIET=$(cat "$dotest/quiet")
255                         while test "$msgnum" -le "$end"
256                         do
257                                 call_merge "$msgnum"
258                                 continue_merge
259                         done
260                         finish_rb_merge
261                         exit
262                 fi
263                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
264                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
265                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
266                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
267                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
268                 move_to_original_branch
269                 exit
270                 ;;
271         --abort)
272                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
273                         die "No rebase in progress?"
274
275                 git rerere clear
276                 if test -d "$dotest"
277                 then
278                         GIT_QUIET=$(cat "$dotest/quiet")
279                         move_to_original_branch
280                 else
281                         dotest="$GIT_DIR"/rebase-apply
282                         GIT_QUIET=$(cat "$dotest/quiet")
283                         move_to_original_branch
284                 fi
285                 git reset --hard $(cat "$dotest/orig-head")
286                 rm -r "$dotest"
287                 exit
288                 ;;
289         --onto)
290                 test 2 -le "$#" || usage
291                 newbase="$2"
292                 shift
293                 ;;
294         -M|-m|--m|--me|--mer|--merg|--merge)
295                 do_merge=t
296                 ;;
297         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
298                 --strateg=*|--strategy=*|\
299         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
300                 case "$#,$1" in
301                 *,*=*)
302                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
303                 1,*)
304                         usage ;;
305                 *)
306                         strategy="$2"
307                         shift ;;
308                 esac
309                 do_merge=t
310                 ;;
311         -n|--no-stat)
312                 diffstat=
313                 ;;
314         --stat)
315                 diffstat=t
316                 ;;
317         -v|--verbose)
318                 verbose=t
319                 diffstat=t
320                 GIT_QUIET=
321                 ;;
322         -q|--quiet)
323                 GIT_QUIET=t
324                 git_am_opt="$git_am_opt -q"
325                 verbose=
326                 diffstat=
327                 ;;
328         --whitespace=*)
329                 git_am_opt="$git_am_opt $1"
330                 case "$1" in
331                 --whitespace=fix|--whitespace=strip)
332                         force_rebase=t
333                         ;;
334                 esac
335                 ;;
336         --committer-date-is-author-date|--ignore-date)
337                 git_am_opt="$git_am_opt $1"
338                 force_rebase=t
339                 ;;
340         -C*)
341                 git_am_opt="$git_am_opt $1"
342                 ;;
343         --root)
344                 rebase_root=t
345                 ;;
346         -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
347                 force_rebase=t
348                 ;;
349         -*)
350                 usage
351                 ;;
352         *)
353                 break
354                 ;;
355         esac
356         shift
357 done
358 test $# -gt 2 && usage
359
360 # Make sure we do not have $GIT_DIR/rebase-apply
361 if test -z "$do_merge"
362 then
363         if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
364         then
365                 rmdir "$GIT_DIR"/rebase-apply
366         else
367                 echo >&2 '
368 It seems that I cannot create a rebase-apply directory, and
369 I wonder if you are in the middle of patch application or another
370 rebase.  If that is not the case, please
371         rm -fr '"$GIT_DIR"'/rebase-apply
372 and run me again.  I am stopping in case you still have something
373 valuable there.'
374                 exit 1
375         fi
376 else
377         if test -d "$dotest"
378         then
379                 die "previous rebase directory $dotest still exists." \
380                         'Try git rebase (--continue | --abort | --skip)'
381         fi
382 fi
383
384 # The tree must be really really clean.
385 if ! git update-index --ignore-submodules --refresh > /dev/null; then
386         echo >&2 "cannot rebase: you have unstaged changes"
387         git diff --name-status -r --ignore-submodules -- >&2
388         exit 1
389 fi
390 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
391 case "$diff" in
392 ?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
393         echo >&2 "$diff"
394         exit 1
395         ;;
396 esac
397
398 if test -z "$rebase_root"
399 then
400         # The upstream head must be given.  Make sure it is valid.
401         upstream_name="$1"
402         shift
403         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
404         die "invalid upstream $upstream_name"
405         unset root_flag
406         upstream_arg="$upstream_name"
407 else
408         test -z "$newbase" && die "--root must be used with --onto"
409         unset upstream_name
410         unset upstream
411         root_flag="--root"
412         upstream_arg="$root_flag"
413 fi
414
415 # Make sure the branch to rebase onto is valid.
416 onto_name=${newbase-"$upstream_name"}
417 onto=$(git rev-parse --verify "${onto_name}^0") || exit
418
419 # If a hook exists, give it a chance to interrupt
420 run_pre_rebase_hook "$upstream_arg" "$@"
421
422 # If the branch to rebase is given, that is the branch we will rebase
423 # $branch_name -- branch being rebased, or HEAD (already detached)
424 # $orig_head -- commit object name of tip of the branch before rebasing
425 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
426 switch_to=
427 case "$#" in
428 1)
429         # Is it "rebase other $branchname" or "rebase other $commit"?
430         branch_name="$1"
431         switch_to="$1"
432
433         if git show-ref --verify --quiet -- "refs/heads/$1" &&
434            branch=$(git rev-parse -q --verify "refs/heads/$1")
435         then
436                 head_name="refs/heads/$1"
437         elif branch=$(git rev-parse -q --verify "$1")
438         then
439                 head_name="detached HEAD"
440         else
441                 usage
442         fi
443         ;;
444 *)
445         # Do not need to switch branches, we are already on it.
446         if branch_name=`git symbolic-ref -q HEAD`
447         then
448                 head_name=$branch_name
449                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
450         else
451                 head_name="detached HEAD"
452                 branch_name=HEAD ;# detached
453         fi
454         branch=$(git rev-parse --verify "${branch_name}^0") || exit
455         ;;
456 esac
457 orig_head=$branch
458
459 # Now we are rebasing commits $upstream..$branch (or with --root,
460 # everything leading up to $branch) on top of $onto
461
462 # Check if we are already based on $onto with linear history,
463 # but this should be done only when upstream and onto are the same.
464 mb=$(git merge-base "$onto" "$branch")
465 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
466         # linear history?
467         ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
468 then
469         if test -z "$force_rebase"
470         then
471                 # Lazily switch to the target branch if needed...
472                 test -z "$switch_to" || git checkout "$switch_to"
473                 say "Current branch $branch_name is up to date."
474                 exit 0
475         else
476                 say "Current branch $branch_name is up to date, rebase forced."
477         fi
478 fi
479
480 # Detach HEAD and reset the tree
481 say "First, rewinding head to replay your work on top of it..."
482 git checkout -q "$onto^0" || die "could not detach HEAD"
483 git update-ref ORIG_HEAD $branch
484
485 if test -n "$diffstat"
486 then
487         if test -n "$verbose"
488         then
489                 echo "Changes from $mb to $onto:"
490         fi
491         # We want color (if set), but no pager
492         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
493 fi
494
495 # If the $onto is a proper descendant of the tip of the branch, then
496 # we just fast forwarded.
497 if test "$mb" = "$branch"
498 then
499         say "Fast-forwarded $branch_name to $onto_name."
500         move_to_original_branch
501         exit 0
502 fi
503
504 if test -n "$rebase_root"
505 then
506         revisions="$onto..$orig_head"
507 else
508         revisions="$upstream..$orig_head"
509 fi
510
511 if test -z "$do_merge"
512 then
513         git format-patch -k --stdout --full-index --ignore-if-in-upstream \
514                 $root_flag "$revisions" |
515         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
516         move_to_original_branch
517         ret=$?
518         test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
519                 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
520                 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
521                 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
522                 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
523         exit $ret
524 fi
525
526 # start doing a rebase with git-merge
527 # this is rename-aware if the recursive (default) strategy is used
528
529 mkdir -p "$dotest"
530 echo "$onto" > "$dotest/onto"
531 echo "$onto_name" > "$dotest/onto_name"
532 prev_head=$orig_head
533 echo "$prev_head" > "$dotest/prev_head"
534 echo "$orig_head" > "$dotest/orig-head"
535 echo "$head_name" > "$dotest/head-name"
536 echo "$GIT_QUIET" > "$dotest/quiet"
537
538 msgnum=0
539 for cmt in `git rev-list --reverse --no-merges "$revisions"`
540 do
541         msgnum=$(($msgnum + 1))
542         echo "$cmt" > "$dotest/cmt.$msgnum"
543 done
544
545 echo 1 >"$dotest/msgnum"
546 echo $msgnum >"$dotest/end"
547
548 end=$msgnum
549 msgnum=1
550
551 while test "$msgnum" -le "$end"
552 do
553         call_merge "$msgnum"
554         continue_merge
555 done
556
557 finish_rb_merge